--- BhyvePkg/Csm/BhyveCsm16/Bios.c.orig	2019-01-28 04:52:37 UTC
+++ BhyvePkg/Csm/BhyveCsm16/Bios.c
@@ -385,6 +385,15 @@ InterruptVector0x15(EFI_IA32_REGISTER_SE
 	  Continuation = 0;
 	}
 
+	/*
+	 * High memory slots may be revoked as long as we're still using EFI,
+	 * so change free slots to "usable by OS after reading ACPI tables".
+	 * This will hopefully avoid memory conflicts with e.g. ISOLINUX.
+	 */
+	if (EfiE820Entry64->BaseAddr > 0x100000 && EfiE820Entry64->Type == 1) {
+	  ((EFI_E820_ENTRY64 *)BufferPointer)->Type = 3;
+	}
+
 	Regs->E.EFlags.CF = 0;
 	Regs->E.EAX = SIGNATURE_32 ('P', 'A', 'M', 'S');
 	Regs->E.ECX = sizeof (EFI_E820_ENTRY64);
